/*
 *  CLI version of ray tracer. 
 */
#include <stdio.h>
#include <stdlib.h>
#include "ray.h"
#include "outputpng.h"

int main(int argc, char *argv[])
{
   int width, height;
   FILE *fp;

   if (argc < 4)
   {
     printf ("Usage: %s <filename> <width> <height> <output>\n", argv[0]);
     return 0;
   }

   width = atoi(argv[2]);
   height = atoi(argv[3]);

   Raytracer R(argv[1], width, height); 

   /* FIXME: emit PNG header first. */ 
   /* safety check */
   if (!(fp = fopen(argv[4], "wb"))) 
   {
     printf ("Could not open output file.\n");
     return 0;
   }
   fclose(fp);

   R.raytraceScene();

   output_png(argv[4], R.getPixels(), width, height);

   return 0;
}

