#!/usr/bin/perl
# generates a helix

  $pi = 3.14159265358979;
  @startlc = ( -.5, 0, .5,
               .5, 0, 0,
               -.5, 0, -.5 );

#  $y_xl = -1;
#  $x_xl = -1;
#  $z_xl = 0;
  $y_xl = -1;
  $x_xl = $z_xl = 0;
  $size = .1;
  $del_rot = 20;

  $num_steps = 15;
  $delx = -2 * $x_xl / $num_steps; 
  $dely = -2 * $y_xl / $num_steps; 
  $delz = -2 * $z_xl / $num_steps;

  $yrot = 0;
#
#  print "Materials: ", $num_steps *3, "\n";
#  for ( $i=0; $i<$num_steps; $i++ ) {
    #// green
    #print "
    #// blue
    #// red
  #}

  print "Objects: ", $num_steps * 3, "\n";
  for ($i=0; $i<$num_steps; $i++ ) {
    @s1 = ($startlc[0], $startlc[1], $startlc[2]);
    @s2 = ($startlc[3], $startlc[4], $startlc[5]);
    @s3 = ($startlc[6], $startlc[7], $startlc[8]);

    @mat = makematrix( $yrot, $x_xl, $y_xl, $z_xl );
    @rp1 = mulptmatrix( @s1, @mat ); 
    @rp2 = mulptmatrix( @s2, @mat ); 
    @rp3 = mulptmatrix( @s3, @mat ); 
    print "Sphere: ",$size, " ", join (' ', @rp1), " ", 0, "\n";  
    print "Sphere: ",$size, " ", join (' ', @rp2), " ", 1, "\n";  
    print "Sphere: ",$size, " ", join (' ', @rp3), " ", 2, "\n";  
 
    $yrot += $del_rot;
    $x_xl += $delx;
    $y_xl += $dely;
    $z_xl += $delz;
  }
  print "Objects.\n";

sub to_rad {
  local ($deg) = @_;

  return $deg * $pi / 180;
}

sub makematrix {
  local ( $yangle, $tx, $ty, $tz ) = @_;

  $y = to_rad ($yangle);
  @matrix = (cos( $y ), 0, sin( $y ), $tx, 
             0, 1, 0, $ty, 
             -sin( $y ), 0, cos( $y ), $tz);
  return @matrix;
}

sub mulptmatrix {
  local ( $x, $y, $z, @matrix ) = @_;

  @rpt = ( $x * $matrix[0] + $y * $matrix[1] + $z * $matrix[2] + $matrix[3],
           $x * $matrix[4] + $y * $matrix[5] + $z * $matrix[6] + $matrix[7],
           $x * $matrix[8] + $y * $matrix[9] + $z * $matrix[10] + $matrix[11] );

  return @rpt;
}
