/*
 *  libpng output driver 
 */
#include <png.h>

int output_png(char *filename, char *pixels, int width, int height)
{
  png_structp png_ptr;
  png_infop info_ptr;
  FILE *fp;
  int i;

  fp = fopen(filename, "wb");
  png_ptr = png_create_write_struct( PNG_LIBPNG_VER_STRING,
                                     NULL, NULL, NULL );
  if (png_ptr)
    info_ptr = png_create_info_struct( png_ptr );

  if (!fp || !png_ptr || !info_ptr || setjmp(png_ptr->jmpbuf)) 
  {
    fprintf(stderr, "PNG Write Error\n");
    fclose(fp);
    if (png_ptr) png_destroy_write_struct( &png_ptr, (png_infopp) NULL );
    return 0;
  }

  png_init_io(png_ptr, fp);
  png_set_IHDR(png_ptr, info_ptr, width, height, 
               8, PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE, 
               PNG_COMPRESSION_TYPE_BASE, PNG_FILTER_TYPE_BASE);

  png_write_info( png_ptr, info_ptr );

  for (i=0; i<height; i++) 
     png_write_row( png_ptr, (png_bytep) &pixels[width * 3 * i] );  

  png_write_end(png_ptr, info_ptr);
  png_destroy_write_struct(&png_ptr, (png_infopp)NULL);
  fclose(fp);
}

