#include <math.h>
#include "misc.h"
#include "object.h"
#include "sphere.h"
#include "vect.h"

Sphere::Sphere(Vect& c, double r) 
{
  int i;

  m_r = r;
  m_c = c;
}

double Sphere::intersect(Vect& start, Vect& dir) 
{
 
  double i, j, k;
  double t1, t2;
  double det, rdet;
  Vect delta = start - m_c;

  i = 1.0;
  j = 2.0 * dir.dot(delta) ;
  k = delta.dot(delta) - m_r * m_r;

  det = j * j - 4 * i * k;

  /* Return -1 if no intersection. */
  if (det < 0.0 ) return (-1.0);
  rdet = sqrt (det);

  t1 = (-j + rdet ) / (2.0 * i);
  t2 = (-j - rdet ) / (2.0 * i);
 
  /* Return smallest nonnegative intersection */

  if (t1 < t2)  {
    if (t1 > 0 + EPSILON) return (t1);
    if (t2 > 0 + EPSILON) return (t2);
  }
  else {
    if (t2 > 0 + EPSILON) return (t2);
    if (t1 > 0 + EPSILON) return (t1);
  }
  return (-1.0);
}

Vect Sphere::getNormal(Vect& location) 
{
  int i;
  Vect n(3);

  /* FIXME: check m_r */
  n = (location - m_c)/m_r;

  return n;
}

