#ifndef T_RAY_HEADER
#define T_RAY_HEADER

/*
 *  This class doesn't restructure the renderer to be threaded
 *  (though it could) -- instead it just wraps the renderer in 
 *  a thread and adds progress reporting.  It does _not_ take
 *  care of race conditions &c; it is intended only for concurrent
 *  processing with the gtk interface.  The other alternative is
 *  of course the windowing system's idle function.
 */
#include <pthread.h>
#include "ray.h"

enum status 
{
  RENDERING,
  IDLE 
};

class TRaytracer : public Raytracer
{
  pthread_t m_thread;
  int m_status;

protected:

public:
  TRaytracer(int width, int height);
  ~TRaytracer();
  void raytraceScene();
  void halt();
  void getProgress(int& x, int& y);
  void getProgress(double& pct);
  int getStatus();
  void setWidth(int width);
  void setHeight(int height);
  void setStep(double step);

  /* really should be protected, I guess.. */
  int setStatus(int);

};

extern "C"
{
  void raytraceThread(TRaytracer *R);
}

#endif
